
`timescale  1 ns / 1 ps



module testbench
  (	
        );
   
   `define top_PB_CLOCK_P_per 37.037
   `define top_clock_per 10
   `define Max_Sim_Time 1000000000     // stop simulation after this time (ns)
   
   reg top_clock;
   reg top_reset_b;
   wire top_PB_CLOCK_P;
   reg top_PB_CLOCK_P_continuous;
   reg top_data_shifting;
   reg top_PB_DATA_P;
   wire [2:0] top_mic_volume;
   wire [2:0] top_song_volume;
   wire [9:0] data_shift_reg; 
   wire [9:0] data_reg;
   wire [7:0] data_bit_count;
   wire latch_data;
   wire top_startup;
   
   volume_buttons my_vol
     (
      .clock(top_clock),
      .reset_b(top_reset_b),
      .PB_CLOCK_P(top_PB_CLOCK_P),
      .PB_DATA_P(top_PB_DATA_P),
      .mic_volume(top_mic_volume),
      .song_volume(top_song_volume),
      .startup(top_startup)
      );

   always #(`top_PB_CLOCK_P_per/2) top_PB_CLOCK_P_continuous = ~top_PB_CLOCK_P_continuous;
   always #(`top_clock_per/2) top_clock = ~top_clock;

   initial begin
      // Initialize TB signals
      top_clock = 1'b0;
      top_PB_CLOCK_P_continuous = 1'b0;
      top_data_shifting = 1'b0;
      top_PB_DATA_P = 1'b0;
             
      top_reset_b = 1'b0;  //reset_b (active low)
      #111;
      top_reset_b = 1'b1;
      
      #10;
      
      // ------------------------------
      // Change Mic Volume to 110
      // ie, want 1000000110 ==> 206 (volume is 6)
      
      top_data_shifting = 1'b1;
      	   top_PB_DATA_P = 1'b1;  // choose mic
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b1;
      #37.037;
	   top_PB_DATA_P = 1'b1;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
      
      top_data_shifting = 1'b0;
      
      top_PB_DATA_P = 1'b0;
      
      // ------------------------------
      // Change Song Volume to 101
      // ie, want 0100000101 ==> 105 (volume is 5)
      
      #185.185;
      
      //top_reset_b = 1'b0;  //reset
            #100;
      //top_reset_b = 1'b1;            
      #10;
          
      top_data_shifting = 1'b1;
      	   top_PB_DATA_P = 1'b0;  
      #37.037;
	   top_PB_DATA_P = 1'b1; // choose song
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b1;
      #37.037;
	   top_PB_DATA_P = 1'b0;
      #37.037;
	   top_PB_DATA_P = 1'b1;
      #37.037;
      
      top_data_shifting = 1'b0;
      
      top_PB_DATA_P = 1'b0;

   end
   
   
   assign top_PB_CLOCK_P = top_PB_CLOCK_P_continuous & top_data_shifting;

///////////////////////////////////////////////////////////////////////////////
// Always End at Max_Sim_Time
///////////////////////////////////////////////////////////////////////////////

initial
  begin
    #(`Max_Sim_Time);
    $stop;
  end

   
endmodule
