#include "xparameters.h"

#define TRUE 1
#define FALSE 0

volatile int *AC97_InFIFO       = XPAR_MY_AC97_BASEADDR;
volatile int *AC97_OutFIFO      = XPAR_MY_AC97_BASEADDR + 0x4;
volatile int *AC97_FIFO_Status  = XPAR_MY_AC97_BASEADDR + 0x8;
volatile int *AC97_RegAddr      = XPAR_MY_AC97_BASEADDR + 0x10;
volatile int *AC97_RegRead      = XPAR_MY_AC97_BASEADDR + 0x14;
volatile int *AC97_RegWrite      = XPAR_MY_AC97_BASEADDR + 0x18;
#define AC97_InFIFO_Full         0x01
#define AC97_InFIFO_Empty        0x02
#define AC97_Reg_Access_Finished 0x10
#define AC97_CODEC_RDY           0x20
#define AC97_REG_ACCESS          0x40
#define AC97_Enable_In_Intr      0x01

void WriteAC97Reg( int reg_addr, int value) {
  *(AC97_RegWrite) = value;
  *(AC97_RegAddr) = reg_addr;
  while (((*(AC97_FIFO_Status)) & AC97_Reg_Access_Finished) == 0);
}

int ReadAC97Reg( int reg_addr) {
  *(AC97_RegAddr) = reg_addr | 0x80;
  while (((*(AC97_FIFO_Status)) & AC97_Reg_Access_Finished) == 0);
  return *(AC97_RegRead);
}

void init_sound(int sample_rate) {
   while (!((*(AC97_FIFO_Status)) & AC97_CODEC_RDY)) {};
   
   WriteAC97Reg(0x2c, sample_rate); 
   
   WriteAC97Reg(0x2a,1); // Enabling VRA mode
   
   WriteAC97Reg(0x02,0x0000);
   WriteAC97Reg(0x04,0x0000);
   WriteAC97Reg(0x06,0x0000);
   WriteAC97Reg(0x0A,0x8000);

   // -------------------------
   WriteAC97Reg(0x18,0x1818);  // PCM Out Volume (atteunate music)
   WriteAC97Reg(0x0E,0x0040);  // Mic Volume (20 dB boost on)
   // -------------------------
   
   WriteAC97Reg(0x20,0x0000);
   //  intc_enable_interrupt(MY_INTC_BASEADDR, XPAR_MY_AC97_INTERRUPT_MASK);
}

#include "mb_interface.h"
void play_sound(int sound){
   microblaze_bwrite_datafsl(sound, 5);   
}

// #include "xparameters.h"
// #include "sound_controller.h"

// /************************************************************
//  * 
//  * Function: WriteAC97Reg 
//  *
//  * Description: Write to a Register on the AC97
//  *
//  * Inputs: reg_addr - AC97 address of register
//  *        value - Value to be writen
//  *
//  * Returns: None
//  * 
//  ************************************************************/
 
// void WriteAC97Reg(Xuint32 BaseAddress, Xuint32 reg_addr, Xuint32 value)
// {
//   XAC97_mSetWriteReg(BaseAddress, value); 
//   XAC97_mSetRegWriteAddr(BaseAddress, reg_addr); 
//   while ((XAC97_mGetStatusReg(BaseAddress) & XAC97_REG_ACCESS_FINISHED) == 0)
//   {
//       ; /* Wait until register write complete */
//   }
// }

// /************************************************************
//  * 
//  * Function: ReadAC97Reg 
//  *
//  * Description: Read a register on the AC97 controller
//  *
//  * Inputs:  reg_addr - the AC97 address of the register
//  *
//  * Returns: register contents
//  * 
//  ************************************************************/

// Xuint32 ReadAC97Reg(Xuint32 BaseAddress, Xuint32 reg_addr)
// {
//   XAC97_mConfReadAccess(BaseAddress, reg_addr);
  
//   while ((XAC97_mGetStatusReg(BaseAddress) & XAC97_REG_ACCESS_FINISHED) == 0)
//   {
//       ; /* Wait until register write complete */
//   }
//   return XAC97_mGetReadData(BaseAddress);
// }

// //#include "xintc_l.h"
// void init_sound(int sample_rate) {
//    XAC97_mSetControlReg(XPAR_MY_AC97_BASEADDR, 0x00000001); /* clear FIFO's */

//    while (!(XAC97_mGetStatusReg(XPAR_MY_AC97_BASEADDR) & XAC97_CODEC_RDY))
//    {
//       ; /* wait until AC97 Codec is ready for use */
//    }

//    /* Enabling VRA mode*/
//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_STATUS_CONTROL_REG, XAC97_VARIABLE_RATE_AUDIO_BIT);
   
//    /* Volume Fixed at Max */
//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_STEREO_VOLUME_REG, XAC97_MAX_VOLUME);

//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_AUX_VOLUME_REG, XAC97_MAX_VOLUME);

//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_MONO_VOLUME_REG, XAC97_MAX_VOLUME);

//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_BEEP_VOLUME_REG, 0x8000);

//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_PCM_OUT_VOLUME_REG, 0x0B0B);
   
//    WriteAC97Reg(XPAR_MY_AC97_BASEADDR, XAC97_PCM_DAC_SAMPLE_RATE_REG, sample_rate);
   
// }

// #include "mb_interface.h"
// void play_sound(int sound){
//    microblaze_bwrite_datafsl(sound, 5);
// }

// #ifdef TEST_SOUND
// void main() {
//    int i;
//    init_sound(44100);
   
//    print ("PLAYING SOUND ...\n");

//    for (i = 0; i < 1916928; i+=2) {
//       play_sound((int) (*((volatile int *) (0xfc800000+i))));
//    }                 
// }
// #endif
