-------------------------------------------------------------------------------
-- zbt_dcm_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library dcm_block_v2_00_a;
use dcm_block_v2_00_a.all;

entity zbt_dcm_wrapper is
  port (
    CLKIN : in std_logic;
    CLKFB : in std_logic;
    DSSEN : in std_logic;
    PSINCDEC : in std_logic;
    PSEN : in std_logic;
    PSCLK : in std_logic;
    RST : in std_logic;
    CLK0 : out std_logic;
    CLK90 : out std_logic;
    CLK180 : out std_logic;
    CLK270 : out std_logic;
    CLK2X : out std_logic;
    CLK2X180 : out std_logic;
    CLKDV : out std_logic;
    CLKFX : out std_logic;
    CLKFX180 : out std_logic;
    LOCKED : out std_logic;
    PSDONE : out std_logic;
    STATUS : out std_logic_vector(7 downto 0);
    RESET_IN : in std_logic;
    FPGA_DONE : in std_logic;
    RESET_OUT : out std_logic
  );
end zbt_dcm_wrapper;

architecture STRUCTURE of zbt_dcm_wrapper is

  component dcm_block is
    port (
      CLKIN : in std_logic;
      CLKFB : in std_logic;
      DSSEN : in std_logic;
      PSINCDEC : in std_logic;
      PSEN : in std_logic;
      PSCLK : in std_logic;
      RST : in std_logic;
      CLK0 : out std_logic;
      CLK90 : out std_logic;
      CLK180 : out std_logic;
      CLK270 : out std_logic;
      CLK2X : out std_logic;
      CLK2X180 : out std_logic;
      CLKDV : out std_logic;
      CLKFX : out std_logic;
      CLKFX180 : out std_logic;
      LOCKED : out std_logic;
      PSDONE : out std_logic;
      STATUS : out std_logic_vector(7 downto 0);
      RESET_IN : in std_logic;
      FPGA_DONE : in std_logic;
      RESET_OUT : out std_logic
    );
  end component;

begin

  zbt_dcm : dcm_block
    port map (
      CLKIN => CLKIN,
      CLKFB => CLKFB,
      DSSEN => DSSEN,
      PSINCDEC => PSINCDEC,
      PSEN => PSEN,
      PSCLK => PSCLK,
      RST => RST,
      CLK0 => CLK0,
      CLK90 => CLK90,
      CLK180 => CLK180,
      CLK270 => CLK270,
      CLK2X => CLK2X,
      CLK2X180 => CLK2X180,
      CLKDV => CLKDV,
      CLKFX => CLKFX,
      CLKFX180 => CLKFX180,
      LOCKED => LOCKED,
      PSDONE => PSDONE,
      STATUS => STATUS,
      RESET_IN => RESET_IN,
      FPGA_DONE => FPGA_DONE,
      RESET_OUT => RESET_OUT
    );

end architecture STRUCTURE;
